;
;      To plot 1D slice for 1D test simulations
;      2006.1.20(the)
;
;  Usage:
;
;  idl> .r dread1
;  idl> .r vonz1D1
;
;max min of vz


vxmx1=fltarr(mfile+1)

bbav1=fltarr(mfile+1)

b0=sqrt(2.0)
vsq=v1*v1+v2*v2+v3*v3
gf=1./sqrt(1.-vsq)
bsq=b1*b1+b2*b2+b3*b3
te=pp/dd
gam=4.0/3.0
h=1.0+gam*te/(gam-1.0)
roh=dd*h
va=sqrt(bsq/(roh+bsq))

eymx1=fltarr(mfile+1)

for mm=1,mfile do begin

 vxmx2=0.0
 bbav2=0.0
 eymx2=0.0
 
 tnum=0.0


 for i=0, ixmax-1 do begin
  for j=0, iymax-1 do begin 


    if(abs(v1(i,j,mm)) le 0.9 and vxmx2 le abs(v1(i,j,mm))) then begin
      vxmx2=v1(i,j,mm)
    endif

    bbav2=bbav2+0.5*(b1(i,j,mm)^2+b2(i,j,mm)^2+b3(i,j,mm)^2)

    
    if(eymx2 le abs(e3(i,j,mm))) then begin
      eymx2=abs(e3(i,j,mm))
    endif  
      
    tnum=tnum+1.0
  endfor
 endfor 

 vxmx1(mm)=vxmx2

 bbav1(mm)=bbav2/tnum
 
 eymx1(mm)=eymx2
endfor

end
